import React, {Component} from 'react';
import PropTypes from 'prop-types';

export default function(loadModule){

	class Bundle extends Component {
		
		static preload(){
			loadModule.default.load(() => {});
		}

		constructor(){
			super(...arguments)
			this.state = {
				mod: null
			}
			if(process.env.SIDE === 'server'){
				console.log(loadModule.default.component.default);
				this.state = {
					mod: loadModule.default.component.default
				}
				this.props.client.registerChunk(loadModule.default.chunkName);
			}else if(process.env.SIDE === 'client'){
				const id = loadModule.default.id;
				if(this.hasModule(id)){
					this.state = {
						mod: __webpack_require__(id).default
					}
				}else{
					this.state = {
						mod: null
					}
				}
			}
		}

		hasModule(id){
			return !!__webpack_modules__[id];
		}

		componentDidMount() {
			if(process.env.SIDE === 'client'){
				const id = loadModule.default.id;
				if(!this.hasModule(id)){
					this.load(this.props);
				}
			}
		}

		load(props){
			loadModule.default.load((mod) => {
				this.setState({
					mod: mod.default ? mod.default : mod
				});
			})
		}

		render(){
			const Component = this.state.mod;
			return Component ? <Component {...this.props} /> : null;
		}
	}

	Bundle.propTypes = {
		
	}

	const mapStateToProps = state => {
		return {
			client: getClient(state)
		}
	}

	return App.connect(mapStateToProps)(Bundle);
}