var bundle = require('./bundle.js').default;
var loaderUtils = require("loader-utils");

module.exports = {
	bundle: bundle
}
module.exports.pitch = function(remainingRequest) {
	this.cacheable && this.cacheable();
	var query = loaderUtils.getOptions(this) || {};
	var options = {
		content: this.resourcePath,
		context: query.context || this.options.context,
		regExp: query.regExp
	};
	var chunkName = JSON.stringify(loaderUtils.interpolateName(this, "[hash:5]", options));

	var result = [];
	if(process.env.SIDE === 'client') {
		result = [
			"var module_id = require.resolveWeak(", loaderUtils.stringifyRequest(this, "!!" + remainingRequest), ");\n",
			"var fn = function(cb) {\n",
			"	require.ensure([], function(require) {\n",
			"		var module = require(", loaderUtils.stringifyRequest(this, "!!" + remainingRequest), ");\n",
			"		cb(module);\n",
			"	}," + chunkName + ");\n",
			"}\n",
			"module.exports.default = {\n",
				"id: module_id,\n",
				"chunkName: " + chunkName + ",\n",
				"load: fn\n",
			"};\n"
			];
	} else if (process.env.SIDE === 'server') {
		result = [
			"var obj = require(", loaderUtils.stringifyRequest(this, "!!" + remainingRequest), ");\n",
			"module.exports.default = {\n",
				"chunkName: " + chunkName + ",\n",
				"component: obj\n",
			"};\n"
		]
	} else {
		throw new Error("process.env.SIDE must be one of 'client' or 'server'.");
	}
	return result.join("");
}